package com.fuzamei.dao;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import com.fuzamei.entity.UserDetail;
import com.fuzamei.mapperInterface.UserAuthoricationMapper;

/**
 * 
 * @author ylx
 * @describe 用于查询用户的信息的dao层类
 */
@Repository
public class UserAuthoricationDao {
	
	@Autowired
	private UserAuthoricationMapper userAuthoricationMapper;
	
	//根据用户的id号查询用户的角色信息 
	public List<String> queryUserRoleNames(int userId){
		return userAuthoricationMapper.queryUserRolenames(userId);
	}
	
	//根据用户的id号查询用户的权限信息 
	public List<String> queryUserPermissionNames(int userId){
		return userAuthoricationMapper.queryUserPermissionNames(userId);
	}
	
	//根据用户的id号查询用户的账号名Account名
	public String queryUserAccount(int userId) {
		return userAuthoricationMapper.queryUserAccount(userId);
	}
	
	//根据id号查询用户全部的信息
	public UserDetail queryUserDetailInformation(int userId) {
		return userAuthoricationMapper.queryUserDetailInformation(userId);
	}
}
