package com.fuzamei.service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.fuzamei.dao.AccountMaintenanceDao;
import com.fuzamei.entity.AccountOpeningRecord;
import com.fuzamei.utils.PageDTO;

@Service
public class AccountMaintenanceService {
   @Autowired
   private AccountMaintenanceDao  accountMaintenanceDao;
   private static final int ROW_NUM = 10; // 分页每页显示数据的数量
   
   /**
    * 添加  上传  账户维护信息
    * @param map
    */
   @Transactional
	public void insertIntoAccountINfo(Map<String, Object> map) {
		String customer_id="";   //ID   
		String customer_name="";//客户名称
		String bank_account="";//银行账号
		String hash="";//上传三个文件  应该产生几个hash值？？？？？？操作hash？
	
		//省略几个直接put进去
		String basicAttachment_id="";    //基本资料附件id
		String basicAttachment_name="";  //基本资料附件名称
		String basicUrl="";              //基本资料附件url
		String basicUpload_person_id=""; //基本资料附件上传人的id
	    long basicCreate_time=0;      //基本资料附件添加的时间
		
	    String  letterAttachment_id="";    //承诺书附件id
		String letterAttachment_name="";  //承诺书附件名称
		String letterUrl="";              //承诺书附件url
		String letterUpload_person_id=""; //承诺书附件上传人的id
	    long letterCreate_time=0;      //承诺书附件添加的时间
	    
	    String applicationAttachment_id="";    //开户申请书附件id
		String applicationAttachment_name="";  //开户申请书附件名称
		String applicationUrl="";              //开户申请书附件url
		String applicationUpload_person_id=""; //开户申请书附件上传人的id
	    long applicationCreate_time=0;      //开户申请书附件添加的时间
	
	    if (!"".equals(map.get("customer_id")) && map.get("customer_id") != null) { 
	    	customer_id = String.valueOf(map.get("customer_id"));
		}
		if (!"".equals(map.get("customer_name")) && map.get("customer_name") != null) { 
			customer_name = (String) map.get("customer_name");
		}
		if (!"".equals(map.get("bank_account")) && map.get("bank_account") != null) { 
			bank_account = (String) map.get("bank_account");
		}
		
		if (!"".equals(map.get("basicAttachment_id")) && map.get("basicAttachment_id") != null) { 
			basicAttachment_id = String.valueOf(map.get("basicAttachment_id"));
		}
		if (!"".equals(map.get("basicAttachment_name")) && map.get("basicAttachment_name") != null) { 
			basicAttachment_name = (String) map.get("basicAttachment_name");
		}
		if (!"".equals(map.get("basicUrl")) && map.get("basicUrl") != null) { 
			basicUrl = (String) map.get("basicUrl");
		}
		if (!"".equals(map.get("basicUpload_person_id")) && map.get("basicUpload_person_id") != null) { 
			basicUpload_person_id = (String) map.get("basicUpload_person_id");
		}
		if (!"".equals(map.get("basicCreate_time")) && map.get("basicCreate_time") != null) { 
			basicCreate_time = (Long) map.get("basicCreate_time");
		}
		
		if (!"".equals(map.get("letterAttachment_id")) && map.get("letterAttachment_id") != null) { 
			letterAttachment_id =  String.valueOf(map.get("letterAttachment_id"));
		}
		if (!"".equals(map.get("letterAttachment_name")) && map.get("letterAttachment_name") != null) { 
			letterAttachment_name = (String) map.get("letterAttachment_name");
		}
		if (!"".equals(map.get("letterUrl")) && map.get("letterUrl") != null) { 
			letterUrl = (String) map.get("letterUrl");
		}
		if (!"".equals(map.get("letterUpload_person_id")) && map.get("letterUpload_person_id") != null) { 
			letterUpload_person_id = (String) map.get("letterUpload_person_id");
		}
		if (!"".equals(map.get("letterCreate_time")) && map.get("letterCreate_time") != null) { 
			letterCreate_time = (Long) map.get("letterCreate_time");
		}
		
		if (!"".equals(map.get("applicationAttachment_id")) && map.get("applicationAttachment_id") != null) { 
			applicationAttachment_id = String.valueOf(map.get("applicationAttachment_id"));
		}
		if (!"".equals(map.get("applicationAttachment_name")) && map.get("applicationAttachment_name") != null) { 
			applicationAttachment_name = (String) map.get("applicationAttachment_name");
		}
		if (!"".equals(map.get("applicationUrl")) && map.get("applicationUrl") != null) { 
			applicationUrl = (String) map.get("applicationUrl");
		}
		if (!"".equals(map.get("applicationUpload_person_id")) && map.get("applicationUpload_person_id") != null) { 
			applicationUpload_person_id = (String) map.get("applicationUpload_person_id");
		}
		if (!"".equals(map.get("applicationCreate_time")) && map.get("applicationCreate_time") != null) { 
			applicationCreate_time = (Long) map.get("applicationCreate_time");
		}
		
		 SimpleDateFormat df = new SimpleDateFormat("yyyyMMHHmmss");
		    String ss=  df.format(new Date());
	    
		    Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
			  mapToDao.put("customer_id", "201712"+Math.round(Math.random()*8999+100));//ID先写成随机数   到时候不行在改
			  mapToDao.put("customer_name",customer_name );
			  mapToDao.put("bank_account","622707"+ss);//银行帐号 产生不能一样    这里是用Date时间做账号   18位数     //直接put进来  Action  可以不要
			  mapToDao.put("basicAttachment_id", basicAttachment_id);//基本资料id
			  mapToDao.put("letterAttachment_id", letterAttachment_id);//承诺书id    
			  mapToDao.put("applicationAttachment_id", applicationAttachment_id);//申请书id
			  mapToDao.put("update_time",  System.currentTimeMillis());//更新时间
			  mapToDao.put("status_id",  9);//状态写的是死值    9状态代表已完成   因为 刚注册开完户的用户账号就要能使用  
			  mapToDao.put("hash","ccccccc");//哈希值暂时写的是个字符串死值   操作hash？？？？
			      accountMaintenanceDao.insertIntoAccountMaintenanceInfo(mapToDao);
	    
			  
			  Map<String, Object> mapToDaoBasic = new LinkedHashMap<String, Object>();  
				  mapToDaoBasic.put("attachment_id", basicAttachment_id);
				  mapToDaoBasic.put("attachment_name", basicAttachment_name);
				  mapToDaoBasic.put("url", basicUrl);  
				  mapToDaoBasic.put("upload_person_id", 10085);//写的是死值  到时候在改    目前id号是写死，到时候需要动态获取这个信息
				  mapToDaoBasic.put("create_time", mapToDao.get("update_time"));
				  accountMaintenanceDao.insertAccountMaintenanceInfoFuJianBiao(mapToDaoBasic);//上传其他凭证      到附件表
			
			 
			 Map<String, Object> mapToDaoLetter = new LinkedHashMap<String, Object>();  
				 mapToDaoLetter.put("attachment_id", letterAttachment_id);
				 mapToDaoLetter.put("attachment_name", letterAttachment_name);
				 mapToDaoLetter.put("url", letterUrl);
				 mapToDaoLetter.put("upload_person_id", 10085);//写的是死值   到时候在改     待改动   目前id号是写死，到时候需要动态获取这个信息
				 mapToDaoLetter.put("create_time", mapToDao.get("update_time"));
				 accountMaintenanceDao.insertAccountMaintenanceInfoFuJianBiao(mapToDaoLetter);//上传承诺书的       到附件表
			   
			 Map<String, Object> mapToDaoApplication = new LinkedHashMap<String, Object>();  
				 mapToDaoApplication.put("attachment_id", applicationAttachment_id);
				 mapToDaoApplication.put("attachment_name", applicationAttachment_name);
				 mapToDaoApplication.put("url", applicationUrl);
				 mapToDaoApplication.put("upload_person_id", 10085);//写的是死值    到时候在改  ？?    待改动  目前id号是写死，到时候需要动态获取这个信息
				 mapToDaoApplication.put("create_time", mapToDao.get("update_time"));
				 accountMaintenanceDao.insertAccountMaintenanceInfoFuJianBiao(mapToDaoApplication);//上传开户申请书的       到附件表
			     
			//还要将账户开立添加上传的这个操作信息插入到操作记录表中
			Map<String, Object> mapToOperationHistory = new LinkedHashMap<String,Object>();
				mapToOperationHistory.put("operatorTypeId", 1001);						//
				mapToOperationHistory.put("operatorAccount", 500000255);				//操作账号先写死
				mapToOperationHistory.put("operatorRole", "经办支行");						//创建这个操作的角色
				mapToOperationHistory.put("operatorPerson", "张五");						//操作人先写死
				mapToOperationHistory.put("operatorTime", mapToDao.get("update_time")); //操作时间为当前操作时间
				mapToOperationHistory.put("hash", "操作hash值3");	                       //写的时死值
				accountMaintenanceDao.insertAccountMaintenanceInfoOperationHistory(mapToOperationHistory);           //将账户开立添加上传的操作记录信息插入到操作记录表中     
	}
    /**
     * 查看账户维护开立信息 列表
     * @param map
     * @return
     */
    public  PageDTO selectAccountMaintenanceInfo(Map<String,Object> map) {
    	int page = 1; // 默认页是第一页
		String customer_name = ""; // 
		String bank_account = ""; // 
		long startTime = 0; // 开始时间默认0
		long endTime = Long.MAX_VALUE; // 结束时间默认Long最大值
		if (!"".equals(map.get("page")) && map.get("page") != null) { // 等于空就直接取第一页
			try {
				page = Integer.parseInt((String) map.get("page"));
				if (page < 1) {
					page = 1;
				}
			} catch (NumberFormatException e) {
				page = 1; // 数据解析异常page还是1
			}
		}
		if (!"".equals(map.get("customer_name")) && map.get("customer_name") != null) { // 等于空就直接取空值
			customer_name = (String) map.get("customer_name");
		}
		if (!"".equals(map.get("bank_account")) && map.get("bank_account") != null) { // 等于空就直接取空值
			bank_account = (String) map.get("bank_account");
		}
		if (!"".equals(map.get("startTime")) && map.get("startTime") != null) { // 等于空就直接取空值
			try {
				startTime = Long.parseLong((String) map.get("startTime"));
			} catch (NumberFormatException e) {
				startTime = 0; // 数据解析异常startTime还是0
			}
		}
		if (!"".equals(map.get("endTime")) && map.get("endTime") != null) { // 等于空就直接取空值
			try {
				endTime = Long.parseLong((String) map.get("endTime"));
			} catch (NumberFormatException e) {
				endTime = Long.MAX_VALUE; // 数据解析异常endTime还是9223372036854775807L
			}
		}
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		mapToDao.put("startPage", (page - 1) * ROW_NUM);
		mapToDao.put("customer_name", customer_name);
		mapToDao.put("bank_account", bank_account);
		if (startTime <= endTime) {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", endTime);
		} else {
			mapToDao.put("startTime", startTime);
			mapToDao.put("endTime", Long.MAX_VALUE);
		}
		mapToDao.put("rowNum", ROW_NUM); // 默认每页显示数据是10条，可根据需求修改分页数量

		int count = accountMaintenanceDao.selectCountAccountMaintenancePage();
		List<AccountOpeningRecord> list=accountMaintenanceDao.selectAccountMaintenanceInfo(mapToDao);
		pageDto.setTotal(count);
		pageDto.setRows(list);
		return pageDto;
	
    }
	/**账户开立  查看详情 供应下载提示框
	 * postman customer_id  200002/2029
	 * @param map
	 * @return
	 */
	public Map<String, Object> selectAccountMaintenanceNoPage(Map<String, Object> map){
			Integer customer_id=null;   //ID
		    if(!"".equals(map.get("customer_id")) && null!=map.get("customer_id")){
				customer_id = Integer.parseInt((String)map.get("customer_id"));
			}
			Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
				 mapToDao.put("customer_id", customer_id);
				 List<AccountOpeningRecord> AccountMaintenancelist=accountMaintenanceDao.selectAccountMaintenanceNoPage(mapToDao);
				 Map<String, Object> AccountOpenAction = new LinkedHashMap<String, Object>();
				 AccountOpenAction.put("customer_id", customer_id);
				 AccountOpenAction.put("AccountMaintenancelist", AccountMaintenancelist);
				 return AccountOpenAction;
    }
    
    
    

}
