package com.fuzamei.service;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fuzamei.dao.UserAuthoricationDao;
import com.fuzamei.entity.UserDetail;

@Service
public class UserAuthoricationService {
	
	@Autowired
	private UserAuthoricationDao userAuthoricationDao;
	
	
	/**
	 * 
	* @Title: checkUserAuthority
	* @Description: TODO(查看用户是否有权限下载项目文档文件，如果没有权限直接抛出异常,校验结束返回一个UserDetail信息)
	* @param @param userId    设定文件
	* @return UserDetail    返回类型
	* @author ylx
	* @date 2017年12月27日 下午4:51:22
	* @throws
	 */
	public UserDetail checkUserAuthority(int userId,String... authority) {
		UserDetail userDetail = userAuthoricationDao.queryUserDetailInformation(userId);
		if(userDetail==null){
			throw new RuntimeException("用户信息不存在");
		}
		List<String> roleList = userDetail.getRole_name();
		boolean temp = false;
		for (String string : authority) {
			temp=roleList.contains(string)||temp;
		}
		if(!temp){
			throw new RuntimeException("无权操作");
		}
		return userDetail;
		/*if(!(roleList.contains("监管机构")||roleList.contains("省分行托管分中心档案保管岗"))){
			throw new RuntimeException("无权查看项目文档信息");
		}*/
	}
	
	
}
