package com.fuzamei.web;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.alibaba.fastjson.JSON;
import com.fuzamei.service.AccountOpenService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;
import com.fuzamei.utils.ValidationUtil;

@Controller
@RequestMapping(value = "/Account")
public class AccountOpenAction {
	

	@Autowired
	private AccountOpenService  accountService;//注入service
	private static final int ROW_NUM = 10; // 分页每页显示数据的数量(固定10条数据)
    /**
     * 查询账户开立
     * @param data
     * @return
     */
	@RequestMapping(value = "/queryAccountInfo", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> queryAccountInfo(@RequestBody String data) {
		//System.out.println("查询账户开立信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.queryAllAccountOpening(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	
	/**
	 * 查询提示函   管理人接收列表
	 * @param data
	 * @return
	 */
	
	@RequestMapping(value = "/selectPromptLetter", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectPromptLetter(@RequestBody String data) {
		//System.out.println("管理人查询风险提示函信息列表");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.selectPromptLetter(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);
		return mapResult;
	}
	
	/**
	 * 查询提示函 发送人的列表   
	 * @param data
	 * @return
	 */
	@RequestMapping(value = "/selectTishihan", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectTishihan(@RequestBody String data) {
		//System.out.println("查询风险提示函信息列表3 ，省分行托管中心风管岗");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=  accountService.selectTishihan(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
/*	*//**
	 * 账户开立   点击查看  显示下载文件的提示框
	 * @param data
	 * @return
	 *//*
	@RequestMapping(value = "/selectAccountopenNoPage",method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectAccountopenNoPage(@RequestBody String data){
		//System.out.println("账户开立查看....");
		Map<String, Object> map = JSONUtil.jsonToMap(data);	// 将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		Map<String, Object> mapFromService = accountService.selectAccountopenNoPage(map); //这里不要分页，只要service传过来一个map对象即可
		return JSONUtil.getJsonMap(200, true, "操作成功", mapFromService); //将从service返回回来的map对象通过map对象直接返回给前端
	}
	*/
	
	
	
	
	 /**  
     *  账户开立 添加客户名称和银行账号  上传3份资料
     * @param  
     * @param   
     * @throws Exception  
     */
    @RequestMapping(value="/uploadOrInsertBankAccount",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> uploadOrInsertBankAccount(@RequestParam("basic_data_id") MultipartFile file,@RequestParam("letter_of_commitment_id") MultipartFile file2 ,
    		@RequestParam("application_id") MultipartFile file3, HttpServletRequest request,
    	    @RequestParam("customer_name") String customer_name,
    	    @RequestParam("bank_account") String bank_account) throws IOException{
    	try {
    		String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\testCeshi";  
            //String fileName = file.getOriginalFilename();    
              File dir = new File(path);          
              if(!dir.exists()){  
                  dir.mkdirs();   
              }  
          Map<String, Object> map = new LinkedHashMap<String, Object>();
             map.put("customer_name", customer_name);  
             map.put("bank_account", bank_account);//可以不要  不输入参数   直接在service里put进去
     
            //基本资料 
            String fileName = file.getOriginalFilename();  
            String pathFile=path+"/"+fileName;
            File newfile = new File(pathFile); 
            file.transferTo(newfile);
            map.put("basicAttachment_id", 333);//附件id暂时写死
    		map.put("basicAttachment_name", fileName);
    	    map.put("basicUrl","\\testCeshi"+fileName);
    	    
    	    //账户承诺书
    	    String fileName2 = file2.getOriginalFilename();  
            String pathFile2=path+"/"+fileName2;
            File newfile2 = new File(pathFile2); 
            file2.transferTo(newfile2);
            map.put("letterAttachment_id", 444);//附件id暂时写死
    		map.put("letterAttachment_name", fileName2);
    	    map.put("letterUrl","\\testCeshi"+fileName2);
    	    
    	    //开户申请书
       	    String fileName3 = file3.getOriginalFilename();  
            String pathFile3=path+"/"+fileName3;
            File newfile3 = new File(pathFile3); 
            file3.transferTo(newfile3);
            map.put("applicationAttachment_id", 555);//附件id暂时写死
    		map.put("applicationAttachment_name", fileName3);
    	    map.put("applicationUrl","\\testCeshi"+fileName3);
            
    	    accountService.insertAccountUploadFile(map);
    	 
    	    Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传成功了", null);
              return mapResult;
		 } catch (Exception e) {
			Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传失败"+e.getMessage(), null);
			return mapResult ;
		 }
    	
    	
    	
    	
    }
	
	
	
	
	
	
	
	   
}
	

