package com.fuzamei.web;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URLEncoder;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.junit.runners.Parameterized.Parameters;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.entity.CapitalTransfer;
import com.fuzamei.service.CapitalTransferService;
import com.fuzamei.service.UserAuthoricationService;
import com.fuzamei.utils.JSONUtil;
import com.fuzamei.utils.PageDTO;

@Controller
@RequestMapping(value = "CapitalTransfer")
public class CapitalTransferAction {
	@Autowired	
	private CapitalTransferService capitalTransferService;
	@Autowired
	private UserAuthoricationService userAuthoricationService;//参数校验  权限授权
	 /**  
     *  查询资金划转表  省分行托管中心指令业务岗
     * @param  
     * @param   
     * @throws Exception  
     */
	@RequestMapping(value = "/selectCapitalTransfer", method = RequestMethod.POST)
	@ResponseBody
	public Map<String, Object> selectCapitalTransfer(@RequestBody String data) {
      //System.out.println("查询资金划转列表数据");
		Map<String, Object> mapResult = new LinkedHashMap<String, Object>();
		Map<String, Object> map = JSONUtil.jsonToMap(data);
		PageDTO pageDto=capitalTransferService.selectCapitalTransferTable(map);
		mapResult = JSONUtil.getJsonMap(200, true, "操作成功", pageDto);

		return mapResult;
	}
	
	/**{ 
	    "fund_id":"1002"   postman 传id
       }
	 * 资金划转列表点击查看详情
	 * @param data
	 * @return
	 */
	@RequestMapping(value="/selectChaKanZiJinHuaZhuan",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> selectChaKanZiJinHuaZhuan(@RequestBody String data){
		//System.out.println("查看资金划转详情信息....");
		Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
		Map<String, Object> map2= capitalTransferService.selectChaKanZiJinHuaZhuan(map);
		return JSONUtil.getJsonMap(200, true, "操作成功", map2);
		
	}
	/**  
	 * 资金划转下载 doc文档
	 * @param request  
	 * @param response  
	 * @throws Exception  
	 */  
	@RequestMapping(value="/downloadCapitalFile")  
	@ResponseBody 
	public Map<String,Object> downloadCapitalFile(HttpServletRequest request,HttpServletResponse response,@RequestParam("url") String url) throws Exception{  
	    try {
	    	  //模拟文件，456.doc为需要下载的文件  
	        String fileName = request.getSession().getServletContext().getRealPath("")+url;  
	        //获取输入流  
	        InputStream bis = new BufferedInputStream(new FileInputStream(new File(fileName))); 
	        //截取文件名字
	        String filename = url.substring(url.lastIndexOf("/")+1);
	        //转码，免得文件名中文乱码  
	        filename = URLEncoder.encode(filename,"UTF-8");  
	        //设置文件下载头  
	        response.addHeader("Content-Disposition", "attachment;filename=" + filename);    
	        //1.设置文件ContentType类型，这样设置，会自动判断下载文件类型    
	        response.setContentType("multipart/form-data");   
	        BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());  
	        int len = 0;  
	        while((len = bis.read()) != -1){  
	            out.write(len);  
	            out.flush();  
	        }  
	        out.close(); 
	        //返给前端map进行前端提示
	    	return JSONUtil.getJsonMap(200, true, "下载成功",null); 
			
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "下载失败:"+e.getMessage(),null); 
		}
	} 
	/**
	 * 由管理人发起划款资金
	 * @param data
	 * @return
	 */
	@PostMapping(value="/insertCapitalTransfer")
	@ResponseBody
	public Map<String,Object> insertCapitalTransfer(  ){
		
		
		
		
		
		
		
		
		return JSONUtil.getJsonMap(200, true, "划款成功", null);
	}
	
	
	
	/**
	 * 划转资金审核的意见提交
	 * @param data
	 * @return
	 * @return Map<String,Object>返回类型
	 * 
	 */
	@RequestMapping(value="/insertCheckTransfer",method=RequestMethod.POST)
	@ResponseBody
	public Map<String,Object> insertCheckTransfer(@RequestBody String data){
		
		try {
			//System.out.println("添加到划转审核总表信息....");
			Map<String, Object> map = JSONUtil.jsonToMap(data);		//将前端传过来的json数据转化为map对象，并将map对象传入service层进行数据校验
			
			return JSONUtil.getJsonMap(200, true, "添加审核意见成功", null);
		} catch (Exception e) {
			return JSONUtil.getJsonMap(500, false, "添加审核意见失败："+e.getMessage(), null);
		}
		
	}
	
	
	
}
