package com.fuzamei.web;

import java.io.File;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import com.fuzamei.service.TrueFalseSelectService;
import com.fuzamei.utils.HashXiZhiUtil;
import com.fuzamei.utils.JSONUtil;

@Controller
@RequestMapping(value = "/TrueFalseSelect")
public class TrueFalseSelectAction {
	@Autowired
	private TrueFalseSelectService trueFalseSelectService;
	/**  
     * 真伪查询 上传文件  产生一条哈希值
     * @param  
     * @param   
     * @throws Exception  
     */  
    @RequestMapping(value="/trueFalseSelect",method=RequestMethod.POST)  
    @ResponseBody  
    public Map<String,Object> trueFalseSelect(@RequestParam("file") MultipartFile file,HttpServletRequest request) throws IOException{  
       try {
    	   String path = "D:\\tomcate\\apache-tomcat-8.5.24\\webapps"+request.getServletContext().getContextPath()+"\\Ceshi";  
           File dir = new File(path);          
           if(!dir.exists()){  
               dir.mkdirs();  
           }  
           //MultipartFile自带的解析方法  
           String fileName = file.getOriginalFilename();  
           String pathFile=path+"/"+fileName;
           File newfile = new File(pathFile); 
           file.transferTo(newfile);
           
   		   Map<String, Object> map = new LinkedHashMap<String, Object>();
   		   map.put("attachment_name", fileName);
   		   map.put("url",fileName);
   		   trueFalseSelectService.insertTrueFalseSelect(map);
           
           //是上传文件之后才会产生一条哈希值的  然后在对哈希值做操作
          // HashXiZhiUtil.getMd5("D:\\xiangnu\\123.doc");
         String hash=HashXiZhiUtil.getMD5Checksum(pathFile);//调用方法 对（文件）产生一条哈希值
        
        System.out.println( HashXiZhiUtil.getMD5Checksum(pathFile)+"--哈希值");//测试
       	Map<String, Object> mapResult=JSONUtil.getJsonMap(200, true, "上传成功", null);//将查询出来的结果封装成map数据返回
       	//mapResult.put("hash", hash);返回哈希值给前端
       	 return mapResult ;
		}
       catch (Exception e) {
			Map<String, Object> mapResult=JSONUtil.getJsonMap(500, true, "上传失败"+e.getMessage(), null);
			return mapResult ;
		}
    }  
	
	
	
	
	
	
}
